% This script will crate automatically
% the TCL files for building 
% parameters, inputs and outputs trees, using SPC mds-matlab-structs
% functions (liked in a git submodule)
%
% it is assumed that the main algo_cfs12combined_tp
% structure is already present in the base workspace
%
% if successfully executed the three generated TCL scripts:
% /tmp/<username>/cfs12combined_tp.tcl
% /tmp/<username>/cfs12combined_inbus.tcl
% /tmp/<username>/cfs12combined_outbus.tcl
% can be executed by a MDSplus tree edit enabled user via:
% cat /tmp/<username>/cfs12combined_tp.tcl | mdstcl
% and so on

addpath ../../mds/mds-matlab-structs

%% tunable parameters
tpsrc=Simulink.data.evalinGlobal('algo_cfs12combined','algo_cfs12combined_tp_tmpl').Value;
tpsrcpad=struct();
tpsrcpad.cfs12combined.params=tpsrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(tpsrcpad,'cfs12combined_tp.tcl','scdds','value')
clear tpsrc tpsrcpad

%% input bus
inbus=Simulink.data.evalinGlobal('algo_cfs12combined','algo_cfs12combined_inBus');
inbussrc=Simulink.Bus.createMATLABStruct('inbus');
inbussrcpad.cfs12combined.inputs=inbussrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(inbussrcpad,'cfs12combined_inbus.tcl','scdds','data','full_name','dim','signal')
clear inbus inbussrc inbussrcpad

%% output bus
outbus=Simulink.data.evalinGlobal('algo_cfs12combined','algo_cfs12combined_outBus');
outbussrc=Simulink.Bus.createMATLABStruct('outbus');
outbussrcpad.cfs12combined.outputs=outbussrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(outbussrcpad,'cfs12combined_outbus.tcl','scdds','data','full_name','dim','signal')
clear outbus outbussrc outbussrcpad

%% metadata channels
metach.cfs12combined.system.ch01=single(0);
metach.cfs12combined.system.ch02=single(0);
metach.cfs12combined.system.ch03=single(0);
metach.cfs12combined.system.ch04=single(0);
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(metach,'cfs12combined_system.tcl','scdds','data','full_name','dim','signal')
clear metach

